;   RCXTRACE.COM ist ein Hexadezimal-Trace-Programm fr PCs und kompatible
;         mit FIFO-Untersttzung. Lnge: nur 141 Bytes !!!

TERMINAL: MOV   AX,00003     ; Bildschirmmodus: Text 80x25, 16 Farben
          INT   010

          MOV   CX,003F8     ; Port-Grundadresse fr COM1: = $3F8, COM2: = $2F8
                             ;                       COM3: = $3E8, COM4: = $2E8
          MOV   BX,CX        ; Schnittstellenparameter festlegen:
          ADD   BL,003
          MOV   DX,BX
          MOV   AL,083       ; LCR: DLAB setzen
          OUT   (DX),AL
          MOV   DX,CX        ; bertragungsrate: 115200 Hz / 48 = 2400 Bd
          MOV   AL,030       ;  DLL: Frequenzteiler (Lo-Byte) = $30
          OUT   (DX),AL
          INC   DX
          MOV   AL,000       ;  DLM: Frequenzteiler (Hi-Byte) = $00
          OUT   (DX),AL

          XCHG  DX,BX
          MOV   AL,00B       ; LCR: Datenformat 8 O 1
          OUT   (DX),AL

          XCHG  DX,BX
          MOV   AL,000       ; IER: Alle Interrupts sperren
          OUT   (DX),AL
          INC   DX
          MOV   AL,007
          OUT   (DX),AL      ; FCR: FIFOs freigeben und lschen

          XCHG  DX,BX
          INC   DX           ; MCR: RTS setzen, alle anderen Ausgnge lschen
          MOV   AL,002
          OUT   (DX),AL
          INC   DX           ; DX adressiert LSR, CX adressiert RBR/THR

EMPFTEST: IN    AL,(DX)      ; LSR: Schnittstellenstatus holen
          AND   AL,001       ;  Empfangsdaten bereit?
          JZ    SENDTEST     ;  Keine Daten: Tastatur abfragen

WRITE:    XCHG  DX,CX        ; Daten empfangen: auf dem Bildschirm ausgeben
          IN    AL,(DX)      ; RBR: Empfangsdaten lesen
          CALL  PUTHEX2      ;  als zweistellige Hexzahl ausgeben
          CALL  PUTSPC       ;  1 Leerzeichen hinterher
          XCHG  DX,CX

SENDTEST: MOV   AH,001       ; Tastaturstatus abfragen: Zeichen vorhanden ?
          INT   016
          JZ    EMPFTEST     ; Kein Tastendruck: Datenempfang prfen

LIES:     MOV   AH,000       ; Zeichen aus dem Tastaturpuffer holen
          INT   016
          CMP   AX,02D00     ; Alt-X gedrckt ?
          JZ    RAUS         ;  Ja: Zurck ins DOS
          MOV   BL,AL        ;  Nein: auf Sendebereitschaft warten
WARTE:    IN    AL,(DX)
          AND   AL,020       ; LSR: Bit THRE gesetzt ?
          JZ    WARTE

          MOV   AL,BL
          XCHG  DX,CX  
          OUT   (DX),AL      ; THR: Zeichen absenden
          XCHG  DX,CX
          JMP   EMPFTEST     ; Auf neues empfangenes Zeichen warten

RAUS:     MOV   AH,04C       ; Zurck ins DOS
          INT   021

;------------------------------------------------------------------------------
;
;         Hilfsprogramme zur Zeichen-(Ketten-)Ausgabe
;
;------------------------------------------------------------------------------

PUTSPC:   PUSH  AX              ; 1 Leerzeichen ausgeben
          MOV   AL,020
          JMP   PCLABEL

PUTCHAR:  PUSH  AX              ; Einzelzeichen in AL ausgeben
PCLABEL:  PUSH  BX
          MOV   AH,00E
          MOV   BX,00007
          INT   010
          POP   BX
          POP   AX
          RET

PUTHEX2:  PUSH  AX              ; AL als zweistellige Hexzahl ausgeben
          SHR   AL,4
          CALL  PUTHEX1
          POP   AX

PUTHEX1:  PUSH  AX              ; Lo-Nibble in AL als Hexziffer ausgeben
          AND   AL,00F
          CMP   AL,00A
          JC    PH1LABEL
          ADD   AL,007
PH1LABEL: ADD   AL,030
          CALL  PUTCHAR
          POP   AX
          RET

